package net.pricefx.formulaengine.optimization;

import net.pricefx.formulaengine.DatamartContext;

import java.util.Map;

/**
 * The {@link ModelEvaluationFormulaContext} is exposed to model evaluation logics through the <code>model</code> binding.
 * <p>
 * It contains only read-only operations.
 */
public interface ModelEvaluationFormulaContext extends ModelFormulaContextReadOnly {
    final class ForFormulaDeployment implements ModelEvaluationFormulaContext {
        @Override
        public String uniqueName() {
            return null;
        }

        @Override
        public String label() {
            return null;
        }

        @Override
        public Map<String, Object> inputs(String stepName, String tabName) {
            return Map.of();
        }

        @Override
        public Map<String, Object> outputs(String stepName, String calculationName) {
            return Map.of();
        }

        @Override
        public DatamartContext.Table table(String name) {
            return null;
        }
    }
}
